Lua_EnjoyDrawBoxItem = class("Lua_EnjoyDrawBoxItem", Lua_DisplayObject);
function Lua_EnjoyDrawBoxItem:ctor(p)
    self:superCall("ctor", p, "EnjoyDrawBoxItem_skin");
end

function Lua_EnjoyDrawBoxItem:buildShowItem()
    self:superCall("buildShowItem");

    self.subObj.gameObject:SetActive(false);
    self.box:addClickFuntion(self, self.onBoxClick);
    self.box.clickScale = false;
	self.vip_txt = Lua_NumberImage.new(self.content);
	self.vip_txt.prefix = "ui_daily_vip_";
	self.vip_txt.pivot = 1;
	self.vip_txt:setDepth(10);
	self.vip_txt:setLocation(39, -50, 0);
end

function Lua_EnjoyDrawBoxItem:dispose()
	if self.effectBox ~= nil then
		self.effectBox:dispose();
		self.effectBox = nil;			
	end
    self:superCall("dispose");
end

function Lua_EnjoyDrawBoxItem:setData(data)
	self.data = data;

	self.vip_txt.num = data.lvl;
	self.vip_txt:setNumScale(0.8, 0.8)
	self.times.text = data.draw_time;

	if data.state == 2 then
		self.subObj.gameObject:SetActive(true);
		if self.effectBox ~= nil then
			self.effectBox:dispose();
			self.effectBox = nil;			
		end
	else
		self.subObj.gameObject:SetActive(false);
		if DataCenter.vipData.level >= data.lvl and DataCenter.rechargeEnjoyDrawData.time_whole >= data.draw_time then
			if self.effectBox == nil then
				self.effectBox = UICreate.createUIEffect(self.content, "/effects/scsEffects/gui_fallen_gift", "gui_fallen_gift", 0, 0);
				self.effectBox:SetRenderQueue(self.box, 5, 2, false);
			end	
		end
	end
end

function Lua_EnjoyDrawBoxItem:onBoxClick()
	DataCenter.rechargeEnjoyDrawData.boxIndex = self.data.index;
	Lua_WindowUtil.openWin("Lua_RechargeEnjoyDrawReward", WinParam.ACTION_OPEN);
end