Lua_EnjoyDrawRewardItem = class("Lua_EnjoyDrawRewardItem", Lua_ListCell);
function Lua_EnjoyDrawRewardItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_EnjoyDrawRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setCanClick(false);
end

function Lua_EnjoyDrawRewardItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.scale = data._type == 1 and 0.75 or 1;
	self.itemImg.data = data.vo;
	self.itemImg:showMaskSp(false);
	self.itemImg:showNotYetImg(false);
	self.itemImg:setScale(self.scale, self.scale);
end

function Lua_EnjoyDrawRewardItem:onPlayerSoundClick(go)
	if self._data ~= nil then
		Lua_PackUtil.showItemInfo(self._data.vo);
	end
end

function Lua_EnjoyDrawRewardItem:checkOutBound(showRect)
	local width = self.itemImg.item_bg.width * self.scale;
	local height = self.itemImg.item_bg.height * self.scale;
	local rect = Lua_Rectangle.new(self.itemX - width / 2, self.itemY - height / 2, width, height);
	if self._data.subType == Lua_PackTypeDefine.STAMP_ITEM then
		self.itemImg:showStampEff(self._data.show_effect == 1 and showRect:containeRect(rect));
	else
		self.itemImg:showRoundEff(self._data.show_effect == 1 and showRect:containeRect(rect));
	end
end

function Lua_EnjoyDrawRewardItem:dispose()
	if self.itemImg ~= nil then
		self.itemImg:dispose();
		self.itemImg = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end