checkRequire("Lua_EnjoyDrawRewardItem");
Lua_RechargeEnjoyDrawResult = class("Lua_RechargeEnjoyDrawResult", Lua_ThirdSizeWindow);
function Lua_RechargeEnjoyDrawResult:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_RechargeEnjoyDrawResult";
    self.skinName = "RechargeEnjoyDrawTipsWindow_skin";
	self.titleText = LanUtil.getValue(145510);
	self.w = 609;
	self.h = 390;
end

function Lua_RechargeEnjoyDrawResult:buildShowItem()
    self:superCall("buildShowItem");

	-- self.itemWidth = 125;
	-- self.itemHeight = 130;
	self.btnClose:setLocation(272.5,189)
	self.titleBg:setLocation(0,187)
	self.titleNameText:setLocation(0,186)

    self.cancelBtn.label = LanUtil.getValue(145506);
    self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
    self.subBtn:addClickFuntion(self, self.onSubBtnClick);

    self:addLuaEvent("UPDATE_RECHARGE_ENJOY_DRAW_RESULT", self, self.onEnjoyDrawResult);
end

function Lua_RechargeEnjoyDrawResult:dispose()
    self:superCall("dispose");
end

function Lua_RechargeEnjoyDrawResult:onEnjoyDrawResult(msg)
	if msg ~= nil then
		local draw_time = DataCenter.rechargeEnjoyDrawData.draw_time;
		self.infoTxt.text = LanUtil.formateStr(LanUtil.getValue(145505), tostring(draw_time));

		self.drawType = msg.draw_type; -- 抽奖类型 0 一次 1 十次
		if self.drawType == 0 then
	        self.subBtn.label = LanUtil.getValue(145507);
	    elseif self.drawType == 1 then
	        self.subBtn.label = LanUtil.getValue(145508);
	    end

		local list = msg.reward;
		local len = #list;
		if msg.draw_type == 0 then
			local arr = Array();
			for i=1, len do
				local vo = Lua_ToolVo.createToolVo(list[i].id, list[i].amount, list[i].bind);
				vo.star = list[i].equipment.star;
				arr:add({vo = vo, show_effect = list[i].show_effect});
			end
			self:setShowResultData(arr);
		elseif msg.draw_type == 1 then
			local arr = Array();
	        for i = 1, len do 
	            local vo = Lua_ToolVo.createToolVo(list[i].id, list[i].amount, list[i].bind);
				vo.star = list[i].equipment.star;
				arr:add({vo = vo, show_effect = list[i].show_effect, _type = 3});
	        end
	        if self.rewardList == nil then
		        self.rewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 446, 175));
		        self.rewardList:setLocation(-2, 35, 0);
		        self.rewardList:setListCell(Lua_EnjoyDrawRewardItem, 85, 90, 5);
		    end
		    self.rewardList:setLuaArrayData(arr, false);
		end
	end
end

function Lua_RechargeEnjoyDrawResult:setShowResultData(arr)
	if arr:getSize() > 0 then
		if self.rItem ~= nil then
			self.rItem:dispose();
			self.rItem = nil;
		end
        self.rItem = Lua_ToolImage.new(self.content);
		self.rItem:setDepth(5);
		self.rItem:setLocation(0, 40, 0);
		self.rItem:setScale(1, 1, 1);
		self.rItem:setCanClick(true);
		self.rItem.data = arr[1].vo;

		if arr[1].show_effect == 1 then
			self.rItem:showRoundEff(true);
			if roundEff ~= nil then
				self.rItem.roundEff:setSacle(0.9,0.9,0.9);
				self.rItem.roundEff:SetRenderQueue(self.rItem.item_bg, 5, 2, true);
			end
		end
	end
end

function Lua_RechargeEnjoyDrawResult:onCancelBtnClick(go)
	self:hide();
end

function Lua_RechargeEnjoyDrawResult:onSubBtnClick(go)
	self:checkTimeEnough(self.drawType);
end

function Lua_RechargeEnjoyDrawResult:checkTimeEnough(drawType)
	local drawTime = 0;
	local draw_time = DataCenter.rechargeEnjoyDrawData.draw_time;
	local recharge_gold = DataCenter.rechargeEnjoyDrawData.recharge_gold;
	local addTimes = DataCenter.rechargeEnjoyDrawData.addTimes;

	if drawType == 0 then
		drawTime = 1;
	elseif drawType == 1 then
		drawTime = 10;
	end

	if draw_time >= drawTime then
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityDraw(drawType);
	else
		local tipData = {};
	    tipData.des = LanUtil.formateStr(LanUtil.getValue(145512), tostring(recharge_gold), tostring(addTimes));
	    tipData.owner = self;
	    tipData.type = 1;
	    tipData.subFun = self.onSubFun;
	    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
	end
end

function Lua_RechargeEnjoyDrawResult:onSubFun()
	Lua_WindowUtil.openWin("Lua_RechargeEnjoyDrawResult", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_RechargeEnjoyDrawWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end