checkRequire("Lua_EnjoyDrawRewardItem");
Lua_RechargeEnjoyDrawReward = class("Lua_RechargeEnjoyDrawReward", Lua_ThirdSizeWindow);
function Lua_RechargeEnjoyDrawReward:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_RechargeEnjoyDrawReward";
    self.skinName = "RechargeEnjoyDrawTipsWindow_skin";
    self.titleText = LanUtil.getValue(145511);
    self.w = 609;
    self.h = 390;
end

function Lua_RechargeEnjoyDrawReward:buildShowItem()
    self:superCall("buildShowItem");

    self.btnClose:setLocation(272.5,189)
    self.titleBg:setLocation(0,187)
    self.titleNameText:setLocation(0,186)
    if self.redDot == nil then
        self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 233, -111, 0, 0);
        self.redDot:setDepth(5);
        self.redDot.name = "redDot";
        self.redDot:setEnable(false);
    end

    self.rewardList = Lua_DragList.new(self.content, 2, Vector4(0, 0, 408, 100));
    self.rewardList:setLocation(-2, 40, 0);
    self.rewardList:setListCell(Lua_EnjoyDrawRewardItem, 100, 100, 999);

    --self.normalBg:setLocation(-2, 40, 0);
    --self.normalBg:SetDimensions(510, 132);
    self.infoTxt.text = "";
    self.cancelBtn.label = LanUtil.getValue(145509);
    self.cancelBtn:addClickFuntion(self, self.onCancelBtnClick);
    self.subBtn:addClickFuntion(self, self.onSubBtnClick);
    
    self:updatePanelInfo();
    self:addLuaEvent("UPDATE_RECHARGE_ENJOY_DRAW", self, self.updatePanelInfo);
end

function Lua_RechargeEnjoyDrawReward:dispose()
    if self.rewardList ~= nil then
        self.rewardList:dispose();
        self.rewardList = nil;
    end
    self:superCall("dispose");
end

function Lua_RechargeEnjoyDrawReward:updatePanelInfo()
    local arr = DataCenter.rechargeEnjoyDrawData.getRewardWhole;
    local index = DataCenter.rechargeEnjoyDrawData.boxIndex;
    self.data = arr[index];

    local rewardArr = DataCenter.rechargeEnjoyDrawData:getRewardWholeByIndex(index);
    self.rewardNum = rewardArr:getSize();
    self.rewardList:setLuaArrayData(rewardArr, false);
    
    if self.data.state == 2 then
        self.redDot:setEnable(false);
        self.subBtn:setBtnEnable(false);
        self.subBtn.label = LanUtil.getValue(145516);
    else
        if DataCenter.vipData.level >= self.data.lvl and DataCenter.rechargeEnjoyDrawData.time_whole >= self.data.draw_time then
            self.redDot:setEnable(true);
        else
            self.redDot:setEnable(false);
        end
        self.subBtn:setBtnEnable(true);
        self.subBtn.label = LanUtil.getValue(145515);
    end
end

function Lua_RechargeEnjoyDrawReward:onCancelBtnClick(go)
    self:hide();
end

function Lua_RechargeEnjoyDrawReward:onSubBtnClick(go)
    if DataCenter.rechargeEnjoyDrawData.time_whole < self.data.draw_time then
        OperateAlert.show(LanUtil.getValue(145513));
        return;
    end

    if DataCenter.vipData.level < self.data.lvl then
        OperateAlert.show(LanUtil.getValue(145514));
        return;
    end

    local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
    local leftNum = bagData:getLeftSize();
    if leftNum < self.rewardNum then
        DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
        return;
    end

    Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityRewards(Lua_OperationalActivitiesData.RECHARGE_ENJOY_DRAW, self.data.index - 1);
end