checkRequire("Lua_EnjoyDrawRecordItem");
checkRequire("Lua_EnjoyDrawRewardItem");
checkRequire("Lua_EnjoyDrawBoxItem");
Lua_RechargeEnjoyDrawWindow = class("Lua_RechargeEnjoyDrawWindow", Lua_Window);
function Lua_RechargeEnjoyDrawWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RechargeEnjoyDrawWindow";
	self.skinName = "RechargeEnjoyDrawWindow_skin";
end

function Lua_RechargeEnjoyDrawWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.boxArray = Array();
	self.oneRedDot:setEnable(false);
	self.tenRedDot:setEnable(false);

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(299, -132, 558, 300));
	self.dragContainer:setLocation(-543, 130, 0);

	self.rewardList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 448, 190));
	self.rewardList:setListCell(Lua_EnjoyDrawRewardItem, 70, 74, 6);
	self.rewardList:setLocation(298, 123, 0);

	self.pb = UICreate.createProgressBar(self.content, "", "", "common_atlas_1", "common_progress_1_f2", 13, -209, 925, 18);
	self.pb:setBarOffset(2, 3);
	self.pb:setDepth(5);
	self.helpBtn:addClickFuntion(self, self.onHelpBtnClick);
	self.oneBtn:addClickFuntion(self, self.onOneBtnClick);
	self.tenBtn:addClickFuntion(self, self.onTenBtnClick);

	self:addLuaEvent("UPDATE_RECHARGE_ENJOY_DRAW", self, self.updatePanelInfo);
	DataCenter.rechargeEnjoyDrawData:sOpenWindow(1);
	Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sGetActivityInfo(Lua_OperationalActivitiesData.RECHARGE_ENJOY_DRAW);
end

function Lua_RechargeEnjoyDrawWindow:updatePanelInfo()
	if DataCenter.rechargeEnjoyDrawData:checkRedDot() == true then
		DataCenter.redDotData:updateRedDotVoState(22083, false);
	end

	local start_tick = tonumber(DataCenter.rechargeEnjoyDrawData.start_tick);
	local sTimeStr = TimeTransform.getInstance():transSeconds8(start_tick, "yyyy年MM月dd日");
	local end_tick = tonumber(DataCenter.rechargeEnjoyDrawData.end_tick);
	local eTimeStr = TimeTransform.getInstance():transSeconds8(end_tick, "yyyy年MM月dd日");
	self.act_time.text = LanUtil.formateStr(LanUtil.getValue(146008), tostring(sTimeStr .. "-" .. eTimeStr));

	local recharge_gold = DataCenter.rechargeEnjoyDrawData.recharge_gold;
	local addTimes = DataCenter.rechargeEnjoyDrawData.addTimes;
	self.recharge_gold.text = LanUtil.formateStr(LanUtil.getValue(145500), tostring(recharge_gold), tostring(addTimes));

	local has_gold = DataCenter.rechargeEnjoyDrawData.has_gold;
	self.has_gold.text = LanUtil.formateStr(LanUtil.getValue(145502), tostring(has_gold));

	local time_whole = DataCenter.rechargeEnjoyDrawData.time_whole;
	self.time_whole.text = LanUtil.formateStr(LanUtil.getValue(145504), tostring(time_whole));

	local draw_time = DataCenter.rechargeEnjoyDrawData.draw_time;
	self.draw_time.text = LanUtil.formateStr(LanUtil.getValue(145503), tostring(draw_time));
	self.oneRedDot:setEnable(draw_time >= 1);
	self.tenRedDot:setEnable(draw_time >= 10);

	local rewardArr = DataCenter.rechargeEnjoyDrawData.getRewardShow;
	self.rewardList:setLuaArrayData(rewardArr, false);

	local arr = DataCenter.rechargeEnjoyDrawData.getRecordWhole;
	self.dragContainer:removeAllChildren();
	for i = 1, arr:getSize() do
		item = Lua_EnjoyDrawRecordItem.new(self.dragContainer.sub);
		self.dragContainer:addSubContainer(item, false);
		self.dragContainer.childrenList[i]:setData(arr[i]);
	end
	self.dragContainer:updateChildPos();
	self.dragContainer:moveToChildIndex(1, true);

	if DataCenter.rechargeEnjoyDrawData.isBoxCreate == false then
		self:createBoxItem()
		DataCenter.rechargeEnjoyDrawData.isBoxCreate = true;
	else
		self:setBoxItemData();
	end
	self:updateProgressBar();
end

function Lua_RechargeEnjoyDrawWindow:createBoxItem()
	local arr = DataCenter.rechargeEnjoyDrawData.getRewardWhole;
	local len = arr:getSize();
	local maxVal = arr[len].draw_time;
	local num = 925 / len;
	for i = 1, len do
		arr[i].offest = (arr[i].draw_time / maxVal) * len * num - 455 -- 位置偏移
	end

	local item;
	for i = 1, len do
		item = Lua_EnjoyDrawBoxItem.new(self.content);
		item:setLocation(arr[i].offest, -202, 0);
		item:setDepth(1);
		self.boxArray:add(item);
	end
	self:setBoxItemData();
end

function Lua_RechargeEnjoyDrawWindow:setBoxItemData()
	local arr = DataCenter.rechargeEnjoyDrawData.getRewardWhole;
	for i = 1, arr:getSize() do
		self.boxArray[i]:setData(arr[i]);
	end
end

function Lua_RechargeEnjoyDrawWindow:updateProgressBar()
	local time_whole = DataCenter.rechargeEnjoyDrawData.time_whole;
	local list = DataCenter.rechargeEnjoyDrawData.timeWholeList;
	local len = #list;
	local maxVal = list[len];
	if time_whole >= maxVal then
		time_whole = maxVal;
	end
	self.pb:setMaxValue(maxVal);
	self.pb:setValue(time_whole);
end

function Lua_RechargeEnjoyDrawWindow:onHelpBtnClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_OPEN, DataCenter.rechargeEnjoyDrawData.content);
end

function Lua_RechargeEnjoyDrawWindow:onOneBtnClick()
	self:checkTimeEnough(0);
end

function Lua_RechargeEnjoyDrawWindow:onTenBtnClick()
	self:checkTimeEnough(1);
end

function Lua_RechargeEnjoyDrawWindow:checkTimeEnough(drawType)
	local drawTime = 0;
	local draw_time = DataCenter.rechargeEnjoyDrawData.draw_time;
	local recharge_gold = DataCenter.rechargeEnjoyDrawData.recharge_gold;
	local addTimes = DataCenter.rechargeEnjoyDrawData.addTimes;
	if drawType == 0 then
		drawTime = 1;
	elseif drawType == 1 then
		drawTime = 10;
	end

	if draw_time >= drawTime then
		local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
		if bagData:getLeftSize() < drawTime then
			DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
			return;
		end
		Lua_ProxyManager.getProxy("Lua_OperationalActivitiesProxy"):sActivityDraw(drawType);
	else
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {
			owner = self,
			des = LanUtil.formateStr(LanUtil.getValue(145512), tostring(recharge_gold), tostring(addTimes)),
			type = 1,
			subFun = self.onSubFun
		});
	end
end

function Lua_RechargeEnjoyDrawWindow:onSubFun()
	Lua_WindowUtil.openWin("Lua_RechargeEnjoyDrawWindow", WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 1);
end

function Lua_RechargeEnjoyDrawWindow:dispose()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
	if self.dragContainer ~= nil then
		self.dragContainer:dispose();
		self.dragContainer = nil;
	end
	if self.boxArray ~= nil then
		self.boxArray:clear();
	end
	DataCenter.rechargeEnjoyDrawData:sOpenWindow(0);
	DataCenter.rechargeEnjoyDrawData.isBoxCreate = false;
	DataCenter.rechargeEnjoyDrawData.boxIndex = nil;

	self:superCall("dispose");
end